
#define EncoderPort      PORTB 
#define EncoderPortDDR   DDRB
#define enc_pin1         PIND6
#define enc_pin2         PIND7
#define EncoderPinPort   PINB


//#define RIGHT_SPIN 0x01 
//#define LEFT_SPIN 0xff


uint8_t PollEncoder(void);


#define ENCODER_MASK ((1<<enc_pin1)|(1<<enc_pin2))

unsigned char EncState = 0; //  
unsigned char New = 0; //  
unsigned char bufEnc = 0; // 



uint8_t PollEncoder()
{

New  =((EncoderPinPort>>6) & 0b11);

switch(EncState)
	{
	case 2:
		{
		if(New == 3) bufEnc++;
		if(New == 0) bufEnc--; 
		break;
		}
 
	case 0:
		{
		if(New == 2) bufEnc++;
		if(New == 1) bufEnc--; 
		break;
		}
	case 1:
		{
		if(New == 0) bufEnc++;
		if(New == 3) bufEnc--; 
		break;
		}
	case 3:
		{
		if(New == 1) bufEnc++;
		if(New == 2) bufEnc--; 
		break;
		}
	}
   EncState = New;
  return	0;
}
