
/*****************************************************

Chip type               : ATmega168
Program type            : Application
AVR Core Clock frequency: 8,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
     

*****************************************************/

#include <avr/io.h>

char N1, N2,N3, N4,N5,N6, N7, led, bit;    

void lcd_write(void);

//typedef unsigned char byte;

/************       *******************/

  char Numbers[10] = {0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90};                              
   

/************       - *******************/  
 void lcd_init (unsigned long z) 
{
 
{
unsigned long int O1,O2,O3,O4,O5,O6;    

N1 = z / 10000000;                      //            
O1 = z % 10000000;                              
N2 = O1 /1000000 ;                      //  
O2 = O1%1000000;
N3 = O2/100000;                         //          
O3 = O2%100000;
N4 = O3/10000;                          //          
O4 = O3%10000;
N5 = O4/1000;                           //           
O5 = O4%1000;
N6 = O5/100;                            //          
O6 = O5%100;
N7 = O6/10;                             //   

}
lcd_write();

}
 
   
 void send_l(char led)                 //    
  
 { 
        char tmp,t;
		
       	
        tmp=led;
		
       for (t=0; t<8; t++)
		
        { if (tmp & 0x80)
		 
               PORTB |=_BV(PB2);
		
         else PORTB &=~(_BV(PB2));		

        tmp <<= 1; 		
		
        //_delay_us(2);                                            
        
        PORTB &=~(_BV(PB0));
		//_delay_us(2); 
                              
        PORTB |=_BV(PB0);                             

}       
}
  
/************      *********************************/ 
  
 void lcd_write()
{

PORTB &=~(_BV(PB1));

led=(Numbers[(int)N7]); 
send_l(led);
 
led=(Numbers[(int)N6]); 
send_l(led);
 
led=(Numbers[(int)N5]);
led=led|0B10000000; 
send_l(led);
 
led=(Numbers[(int)N4]);
 
send_l(led);
 
led=(Numbers[(int)N3]);
send_l(led);
 
led=(Numbers[(int)N2]);
led=led|0B10000000; 
send_l(led); 

led=(Numbers[(int)N1]);
 
send_l(led); 

PORTB |=_BV(PB1);
 
}

